"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetShardIteratorOutput = exports.GetShardIteratorInput = exports.ShardIteratorType = exports.ProvisionedThroughputExceededException = exports.KMSThrottlingException = exports.KMSOptInRequired = exports.KMSNotFoundException = exports.KMSInvalidStateException = exports.KMSDisabledException = exports.KMSAccessDeniedException = exports.GetRecordsOutput = exports._Record = exports.GetRecordsInput = exports.ExpiredNextTokenException = exports.ExpiredIteratorException = exports.EnableEnhancedMonitoringInput = exports.EnhancedMonitoringOutput = exports.DisableEnhancedMonitoringInput = exports.DescribeStreamSummaryOutput = exports.StreamDescriptionSummary = exports.DescribeStreamSummaryInput = exports.DescribeStreamConsumerOutput = exports.DescribeStreamConsumerInput = exports.DescribeStreamOutput = exports.StreamDescription = exports.StreamStatus = exports.Shard = exports.SequenceNumberRange = exports.EnhancedMetrics = exports.MetricsName = exports.EncryptionType = exports.DescribeStreamInput = exports.DescribeLimitsOutput = exports.DescribeLimitsInput = exports.DeregisterStreamConsumerInput = exports.DeleteStreamInput = exports.DecreaseStreamRetentionPeriodInput = exports.CreateStreamInput = exports.StreamModeDetails = exports.StreamMode = exports.ConsumerDescription = exports.Consumer = exports.ConsumerStatus = exports.ChildShard = exports.HashKeyRange = exports.ResourceNotFoundException = exports.ResourceInUseException = exports.LimitExceededException = exports.InvalidArgumentException = exports.AddTagsToStreamInput = void 0;
exports.UpdateStreamModeInput = exports.UpdateShardCountOutput = exports.UpdateShardCountInput = exports.ScalingType = exports.SubscribeToShardOutput = exports.SubscribeToShardEventStream = exports.SubscribeToShardEvent = exports.SubscribeToShardInput = exports.StartingPosition = exports.StopStreamEncryptionInput = exports.StartStreamEncryptionInput = exports.SplitShardInput = exports.RemoveTagsFromStreamInput = exports.RegisterStreamConsumerOutput = exports.RegisterStreamConsumerInput = exports.PutRecordsOutput = exports.PutRecordsResultEntry = exports.PutRecordsInput = exports.PutRecordsRequestEntry = exports.PutRecordOutput = exports.PutRecordInput = exports.ValidationException = exports.MergeShardsInput = exports.ListTagsForStreamOutput = exports.Tag = exports.ListTagsForStreamInput = exports.ListStreamsOutput = exports.ListStreamsInput = exports.ListStreamConsumersOutput = exports.ListStreamConsumersInput = exports.ListShardsOutput = exports.ListShardsInput = exports.ShardFilter = exports.ShardFilterType = exports.InternalFailureException = exports.IncreaseStreamRetentionPeriodInput = void 0;
const KinesisServiceException_1 = require("./KinesisServiceException");
var AddTagsToStreamInput;
(function (AddTagsToStreamInput) {
    AddTagsToStreamInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(AddTagsToStreamInput = exports.AddTagsToStreamInput || (exports.AddTagsToStreamInput = {}));
class InvalidArgumentException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "InvalidArgumentException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidArgumentException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidArgumentException.prototype);
    }
}
exports.InvalidArgumentException = InvalidArgumentException;
class LimitExceededException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "LimitExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "LimitExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LimitExceededException.prototype);
    }
}
exports.LimitExceededException = LimitExceededException;
class ResourceInUseException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "ResourceInUseException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceInUseException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceInUseException.prototype);
    }
}
exports.ResourceInUseException = ResourceInUseException;
class ResourceNotFoundException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
    }
}
exports.ResourceNotFoundException = ResourceNotFoundException;
var HashKeyRange;
(function (HashKeyRange) {
    HashKeyRange.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(HashKeyRange = exports.HashKeyRange || (exports.HashKeyRange = {}));
var ChildShard;
(function (ChildShard) {
    ChildShard.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ChildShard = exports.ChildShard || (exports.ChildShard = {}));
var ConsumerStatus;
(function (ConsumerStatus) {
    ConsumerStatus["ACTIVE"] = "ACTIVE";
    ConsumerStatus["CREATING"] = "CREATING";
    ConsumerStatus["DELETING"] = "DELETING";
})(ConsumerStatus = exports.ConsumerStatus || (exports.ConsumerStatus = {}));
var Consumer;
(function (Consumer) {
    Consumer.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Consumer = exports.Consumer || (exports.Consumer = {}));
var ConsumerDescription;
(function (ConsumerDescription) {
    ConsumerDescription.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ConsumerDescription = exports.ConsumerDescription || (exports.ConsumerDescription = {}));
var StreamMode;
(function (StreamMode) {
    StreamMode["ON_DEMAND"] = "ON_DEMAND";
    StreamMode["PROVISIONED"] = "PROVISIONED";
})(StreamMode = exports.StreamMode || (exports.StreamMode = {}));
var StreamModeDetails;
(function (StreamModeDetails) {
    StreamModeDetails.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StreamModeDetails = exports.StreamModeDetails || (exports.StreamModeDetails = {}));
var CreateStreamInput;
(function (CreateStreamInput) {
    CreateStreamInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateStreamInput = exports.CreateStreamInput || (exports.CreateStreamInput = {}));
var DecreaseStreamRetentionPeriodInput;
(function (DecreaseStreamRetentionPeriodInput) {
    DecreaseStreamRetentionPeriodInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DecreaseStreamRetentionPeriodInput = exports.DecreaseStreamRetentionPeriodInput || (exports.DecreaseStreamRetentionPeriodInput = {}));
var DeleteStreamInput;
(function (DeleteStreamInput) {
    DeleteStreamInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteStreamInput = exports.DeleteStreamInput || (exports.DeleteStreamInput = {}));
var DeregisterStreamConsumerInput;
(function (DeregisterStreamConsumerInput) {
    DeregisterStreamConsumerInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeregisterStreamConsumerInput = exports.DeregisterStreamConsumerInput || (exports.DeregisterStreamConsumerInput = {}));
var DescribeLimitsInput;
(function (DescribeLimitsInput) {
    DescribeLimitsInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeLimitsInput = exports.DescribeLimitsInput || (exports.DescribeLimitsInput = {}));
var DescribeLimitsOutput;
(function (DescribeLimitsOutput) {
    DescribeLimitsOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeLimitsOutput = exports.DescribeLimitsOutput || (exports.DescribeLimitsOutput = {}));
var DescribeStreamInput;
(function (DescribeStreamInput) {
    DescribeStreamInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeStreamInput = exports.DescribeStreamInput || (exports.DescribeStreamInput = {}));
var EncryptionType;
(function (EncryptionType) {
    EncryptionType["KMS"] = "KMS";
    EncryptionType["NONE"] = "NONE";
})(EncryptionType = exports.EncryptionType || (exports.EncryptionType = {}));
var MetricsName;
(function (MetricsName) {
    MetricsName["ALL"] = "ALL";
    MetricsName["INCOMING_BYTES"] = "IncomingBytes";
    MetricsName["INCOMING_RECORDS"] = "IncomingRecords";
    MetricsName["ITERATOR_AGE_MILLISECONDS"] = "IteratorAgeMilliseconds";
    MetricsName["OUTGOING_BYTES"] = "OutgoingBytes";
    MetricsName["OUTGOING_RECORDS"] = "OutgoingRecords";
    MetricsName["READ_PROVISIONED_THROUGHPUT_EXCEEDED"] = "ReadProvisionedThroughputExceeded";
    MetricsName["WRITE_PROVISIONED_THROUGHPUT_EXCEEDED"] = "WriteProvisionedThroughputExceeded";
})(MetricsName = exports.MetricsName || (exports.MetricsName = {}));
var EnhancedMetrics;
(function (EnhancedMetrics) {
    EnhancedMetrics.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(EnhancedMetrics = exports.EnhancedMetrics || (exports.EnhancedMetrics = {}));
var SequenceNumberRange;
(function (SequenceNumberRange) {
    SequenceNumberRange.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SequenceNumberRange = exports.SequenceNumberRange || (exports.SequenceNumberRange = {}));
var Shard;
(function (Shard) {
    Shard.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Shard = exports.Shard || (exports.Shard = {}));
var StreamStatus;
(function (StreamStatus) {
    StreamStatus["ACTIVE"] = "ACTIVE";
    StreamStatus["CREATING"] = "CREATING";
    StreamStatus["DELETING"] = "DELETING";
    StreamStatus["UPDATING"] = "UPDATING";
})(StreamStatus = exports.StreamStatus || (exports.StreamStatus = {}));
var StreamDescription;
(function (StreamDescription) {
    StreamDescription.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StreamDescription = exports.StreamDescription || (exports.StreamDescription = {}));
var DescribeStreamOutput;
(function (DescribeStreamOutput) {
    DescribeStreamOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeStreamOutput = exports.DescribeStreamOutput || (exports.DescribeStreamOutput = {}));
var DescribeStreamConsumerInput;
(function (DescribeStreamConsumerInput) {
    DescribeStreamConsumerInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeStreamConsumerInput = exports.DescribeStreamConsumerInput || (exports.DescribeStreamConsumerInput = {}));
var DescribeStreamConsumerOutput;
(function (DescribeStreamConsumerOutput) {
    DescribeStreamConsumerOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeStreamConsumerOutput = exports.DescribeStreamConsumerOutput || (exports.DescribeStreamConsumerOutput = {}));
var DescribeStreamSummaryInput;
(function (DescribeStreamSummaryInput) {
    DescribeStreamSummaryInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeStreamSummaryInput = exports.DescribeStreamSummaryInput || (exports.DescribeStreamSummaryInput = {}));
var StreamDescriptionSummary;
(function (StreamDescriptionSummary) {
    StreamDescriptionSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StreamDescriptionSummary = exports.StreamDescriptionSummary || (exports.StreamDescriptionSummary = {}));
var DescribeStreamSummaryOutput;
(function (DescribeStreamSummaryOutput) {
    DescribeStreamSummaryOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeStreamSummaryOutput = exports.DescribeStreamSummaryOutput || (exports.DescribeStreamSummaryOutput = {}));
var DisableEnhancedMonitoringInput;
(function (DisableEnhancedMonitoringInput) {
    DisableEnhancedMonitoringInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DisableEnhancedMonitoringInput = exports.DisableEnhancedMonitoringInput || (exports.DisableEnhancedMonitoringInput = {}));
var EnhancedMonitoringOutput;
(function (EnhancedMonitoringOutput) {
    EnhancedMonitoringOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(EnhancedMonitoringOutput = exports.EnhancedMonitoringOutput || (exports.EnhancedMonitoringOutput = {}));
var EnableEnhancedMonitoringInput;
(function (EnableEnhancedMonitoringInput) {
    EnableEnhancedMonitoringInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(EnableEnhancedMonitoringInput = exports.EnableEnhancedMonitoringInput || (exports.EnableEnhancedMonitoringInput = {}));
class ExpiredIteratorException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "ExpiredIteratorException",
            $fault: "client",
            ...opts,
        });
        this.name = "ExpiredIteratorException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ExpiredIteratorException.prototype);
    }
}
exports.ExpiredIteratorException = ExpiredIteratorException;
class ExpiredNextTokenException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "ExpiredNextTokenException",
            $fault: "client",
            ...opts,
        });
        this.name = "ExpiredNextTokenException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ExpiredNextTokenException.prototype);
    }
}
exports.ExpiredNextTokenException = ExpiredNextTokenException;
var GetRecordsInput;
(function (GetRecordsInput) {
    GetRecordsInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetRecordsInput = exports.GetRecordsInput || (exports.GetRecordsInput = {}));
var _Record;
(function (_Record) {
    _Record.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(_Record = exports._Record || (exports._Record = {}));
var GetRecordsOutput;
(function (GetRecordsOutput) {
    GetRecordsOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetRecordsOutput = exports.GetRecordsOutput || (exports.GetRecordsOutput = {}));
class KMSAccessDeniedException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "KMSAccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "KMSAccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, KMSAccessDeniedException.prototype);
    }
}
exports.KMSAccessDeniedException = KMSAccessDeniedException;
class KMSDisabledException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "KMSDisabledException",
            $fault: "client",
            ...opts,
        });
        this.name = "KMSDisabledException";
        this.$fault = "client";
        Object.setPrototypeOf(this, KMSDisabledException.prototype);
    }
}
exports.KMSDisabledException = KMSDisabledException;
class KMSInvalidStateException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "KMSInvalidStateException",
            $fault: "client",
            ...opts,
        });
        this.name = "KMSInvalidStateException";
        this.$fault = "client";
        Object.setPrototypeOf(this, KMSInvalidStateException.prototype);
    }
}
exports.KMSInvalidStateException = KMSInvalidStateException;
class KMSNotFoundException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "KMSNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "KMSNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, KMSNotFoundException.prototype);
    }
}
exports.KMSNotFoundException = KMSNotFoundException;
class KMSOptInRequired extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "KMSOptInRequired",
            $fault: "client",
            ...opts,
        });
        this.name = "KMSOptInRequired";
        this.$fault = "client";
        Object.setPrototypeOf(this, KMSOptInRequired.prototype);
    }
}
exports.KMSOptInRequired = KMSOptInRequired;
class KMSThrottlingException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "KMSThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "KMSThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, KMSThrottlingException.prototype);
    }
}
exports.KMSThrottlingException = KMSThrottlingException;
class ProvisionedThroughputExceededException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "ProvisionedThroughputExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ProvisionedThroughputExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ProvisionedThroughputExceededException.prototype);
    }
}
exports.ProvisionedThroughputExceededException = ProvisionedThroughputExceededException;
var ShardIteratorType;
(function (ShardIteratorType) {
    ShardIteratorType["AFTER_SEQUENCE_NUMBER"] = "AFTER_SEQUENCE_NUMBER";
    ShardIteratorType["AT_SEQUENCE_NUMBER"] = "AT_SEQUENCE_NUMBER";
    ShardIteratorType["AT_TIMESTAMP"] = "AT_TIMESTAMP";
    ShardIteratorType["LATEST"] = "LATEST";
    ShardIteratorType["TRIM_HORIZON"] = "TRIM_HORIZON";
})(ShardIteratorType = exports.ShardIteratorType || (exports.ShardIteratorType = {}));
var GetShardIteratorInput;
(function (GetShardIteratorInput) {
    GetShardIteratorInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetShardIteratorInput = exports.GetShardIteratorInput || (exports.GetShardIteratorInput = {}));
var GetShardIteratorOutput;
(function (GetShardIteratorOutput) {
    GetShardIteratorOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(GetShardIteratorOutput = exports.GetShardIteratorOutput || (exports.GetShardIteratorOutput = {}));
var IncreaseStreamRetentionPeriodInput;
(function (IncreaseStreamRetentionPeriodInput) {
    IncreaseStreamRetentionPeriodInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(IncreaseStreamRetentionPeriodInput = exports.IncreaseStreamRetentionPeriodInput || (exports.IncreaseStreamRetentionPeriodInput = {}));
class InternalFailureException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "InternalFailureException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalFailureException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalFailureException.prototype);
    }
}
exports.InternalFailureException = InternalFailureException;
var ShardFilterType;
(function (ShardFilterType) {
    ShardFilterType["AFTER_SHARD_ID"] = "AFTER_SHARD_ID";
    ShardFilterType["AT_LATEST"] = "AT_LATEST";
    ShardFilterType["AT_TIMESTAMP"] = "AT_TIMESTAMP";
    ShardFilterType["AT_TRIM_HORIZON"] = "AT_TRIM_HORIZON";
    ShardFilterType["FROM_TIMESTAMP"] = "FROM_TIMESTAMP";
    ShardFilterType["FROM_TRIM_HORIZON"] = "FROM_TRIM_HORIZON";
})(ShardFilterType = exports.ShardFilterType || (exports.ShardFilterType = {}));
var ShardFilter;
(function (ShardFilter) {
    ShardFilter.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ShardFilter = exports.ShardFilter || (exports.ShardFilter = {}));
var ListShardsInput;
(function (ListShardsInput) {
    ListShardsInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListShardsInput = exports.ListShardsInput || (exports.ListShardsInput = {}));
var ListShardsOutput;
(function (ListShardsOutput) {
    ListShardsOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListShardsOutput = exports.ListShardsOutput || (exports.ListShardsOutput = {}));
var ListStreamConsumersInput;
(function (ListStreamConsumersInput) {
    ListStreamConsumersInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListStreamConsumersInput = exports.ListStreamConsumersInput || (exports.ListStreamConsumersInput = {}));
var ListStreamConsumersOutput;
(function (ListStreamConsumersOutput) {
    ListStreamConsumersOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListStreamConsumersOutput = exports.ListStreamConsumersOutput || (exports.ListStreamConsumersOutput = {}));
var ListStreamsInput;
(function (ListStreamsInput) {
    ListStreamsInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListStreamsInput = exports.ListStreamsInput || (exports.ListStreamsInput = {}));
var ListStreamsOutput;
(function (ListStreamsOutput) {
    ListStreamsOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListStreamsOutput = exports.ListStreamsOutput || (exports.ListStreamsOutput = {}));
var ListTagsForStreamInput;
(function (ListTagsForStreamInput) {
    ListTagsForStreamInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForStreamInput = exports.ListTagsForStreamInput || (exports.ListTagsForStreamInput = {}));
var Tag;
(function (Tag) {
    Tag.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Tag = exports.Tag || (exports.Tag = {}));
var ListTagsForStreamOutput;
(function (ListTagsForStreamOutput) {
    ListTagsForStreamOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForStreamOutput = exports.ListTagsForStreamOutput || (exports.ListTagsForStreamOutput = {}));
var MergeShardsInput;
(function (MergeShardsInput) {
    MergeShardsInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(MergeShardsInput = exports.MergeShardsInput || (exports.MergeShardsInput = {}));
class ValidationException extends KinesisServiceException_1.KinesisServiceException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
    }
}
exports.ValidationException = ValidationException;
var PutRecordInput;
(function (PutRecordInput) {
    PutRecordInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutRecordInput = exports.PutRecordInput || (exports.PutRecordInput = {}));
var PutRecordOutput;
(function (PutRecordOutput) {
    PutRecordOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutRecordOutput = exports.PutRecordOutput || (exports.PutRecordOutput = {}));
var PutRecordsRequestEntry;
(function (PutRecordsRequestEntry) {
    PutRecordsRequestEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutRecordsRequestEntry = exports.PutRecordsRequestEntry || (exports.PutRecordsRequestEntry = {}));
var PutRecordsInput;
(function (PutRecordsInput) {
    PutRecordsInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutRecordsInput = exports.PutRecordsInput || (exports.PutRecordsInput = {}));
var PutRecordsResultEntry;
(function (PutRecordsResultEntry) {
    PutRecordsResultEntry.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutRecordsResultEntry = exports.PutRecordsResultEntry || (exports.PutRecordsResultEntry = {}));
var PutRecordsOutput;
(function (PutRecordsOutput) {
    PutRecordsOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(PutRecordsOutput = exports.PutRecordsOutput || (exports.PutRecordsOutput = {}));
var RegisterStreamConsumerInput;
(function (RegisterStreamConsumerInput) {
    RegisterStreamConsumerInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RegisterStreamConsumerInput = exports.RegisterStreamConsumerInput || (exports.RegisterStreamConsumerInput = {}));
var RegisterStreamConsumerOutput;
(function (RegisterStreamConsumerOutput) {
    RegisterStreamConsumerOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RegisterStreamConsumerOutput = exports.RegisterStreamConsumerOutput || (exports.RegisterStreamConsumerOutput = {}));
var RemoveTagsFromStreamInput;
(function (RemoveTagsFromStreamInput) {
    RemoveTagsFromStreamInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RemoveTagsFromStreamInput = exports.RemoveTagsFromStreamInput || (exports.RemoveTagsFromStreamInput = {}));
var SplitShardInput;
(function (SplitShardInput) {
    SplitShardInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SplitShardInput = exports.SplitShardInput || (exports.SplitShardInput = {}));
var StartStreamEncryptionInput;
(function (StartStreamEncryptionInput) {
    StartStreamEncryptionInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StartStreamEncryptionInput = exports.StartStreamEncryptionInput || (exports.StartStreamEncryptionInput = {}));
var StopStreamEncryptionInput;
(function (StopStreamEncryptionInput) {
    StopStreamEncryptionInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StopStreamEncryptionInput = exports.StopStreamEncryptionInput || (exports.StopStreamEncryptionInput = {}));
var StartingPosition;
(function (StartingPosition) {
    StartingPosition.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(StartingPosition = exports.StartingPosition || (exports.StartingPosition = {}));
var SubscribeToShardInput;
(function (SubscribeToShardInput) {
    SubscribeToShardInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SubscribeToShardInput = exports.SubscribeToShardInput || (exports.SubscribeToShardInput = {}));
var SubscribeToShardEvent;
(function (SubscribeToShardEvent) {
    SubscribeToShardEvent.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SubscribeToShardEvent = exports.SubscribeToShardEvent || (exports.SubscribeToShardEvent = {}));
var SubscribeToShardEventStream;
(function (SubscribeToShardEventStream) {
    SubscribeToShardEventStream.visit = (value, visitor) => {
        if (value.SubscribeToShardEvent !== undefined)
            return visitor.SubscribeToShardEvent(value.SubscribeToShardEvent);
        if (value.ResourceNotFoundException !== undefined)
            return visitor.ResourceNotFoundException(value.ResourceNotFoundException);
        if (value.ResourceInUseException !== undefined)
            return visitor.ResourceInUseException(value.ResourceInUseException);
        if (value.KMSDisabledException !== undefined)
            return visitor.KMSDisabledException(value.KMSDisabledException);
        if (value.KMSInvalidStateException !== undefined)
            return visitor.KMSInvalidStateException(value.KMSInvalidStateException);
        if (value.KMSAccessDeniedException !== undefined)
            return visitor.KMSAccessDeniedException(value.KMSAccessDeniedException);
        if (value.KMSNotFoundException !== undefined)
            return visitor.KMSNotFoundException(value.KMSNotFoundException);
        if (value.KMSOptInRequired !== undefined)
            return visitor.KMSOptInRequired(value.KMSOptInRequired);
        if (value.KMSThrottlingException !== undefined)
            return visitor.KMSThrottlingException(value.KMSThrottlingException);
        if (value.InternalFailureException !== undefined)
            return visitor.InternalFailureException(value.InternalFailureException);
        return visitor._(value.$unknown[0], value.$unknown[1]);
    };
    SubscribeToShardEventStream.filterSensitiveLog = (obj) => {
        if (obj.SubscribeToShardEvent !== undefined)
            return { SubscribeToShardEvent: SubscribeToShardEvent.filterSensitiveLog(obj.SubscribeToShardEvent) };
        if (obj.ResourceNotFoundException !== undefined)
            return { ResourceNotFoundException: obj.ResourceNotFoundException };
        if (obj.ResourceInUseException !== undefined)
            return { ResourceInUseException: obj.ResourceInUseException };
        if (obj.KMSDisabledException !== undefined)
            return { KMSDisabledException: obj.KMSDisabledException };
        if (obj.KMSInvalidStateException !== undefined)
            return { KMSInvalidStateException: obj.KMSInvalidStateException };
        if (obj.KMSAccessDeniedException !== undefined)
            return { KMSAccessDeniedException: obj.KMSAccessDeniedException };
        if (obj.KMSNotFoundException !== undefined)
            return { KMSNotFoundException: obj.KMSNotFoundException };
        if (obj.KMSOptInRequired !== undefined)
            return { KMSOptInRequired: obj.KMSOptInRequired };
        if (obj.KMSThrottlingException !== undefined)
            return { KMSThrottlingException: obj.KMSThrottlingException };
        if (obj.InternalFailureException !== undefined)
            return { InternalFailureException: obj.InternalFailureException };
        if (obj.$unknown !== undefined)
            return { [obj.$unknown[0]]: "UNKNOWN" };
    };
})(SubscribeToShardEventStream = exports.SubscribeToShardEventStream || (exports.SubscribeToShardEventStream = {}));
var SubscribeToShardOutput;
(function (SubscribeToShardOutput) {
    SubscribeToShardOutput.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.EventStream && { EventStream: "STREAMING_CONTENT" }),
    });
})(SubscribeToShardOutput = exports.SubscribeToShardOutput || (exports.SubscribeToShardOutput = {}));
var ScalingType;
(function (ScalingType) {
    ScalingType["UNIFORM_SCALING"] = "UNIFORM_SCALING";
})(ScalingType = exports.ScalingType || (exports.ScalingType = {}));
var UpdateShardCountInput;
(function (UpdateShardCountInput) {
    UpdateShardCountInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateShardCountInput = exports.UpdateShardCountInput || (exports.UpdateShardCountInput = {}));
var UpdateShardCountOutput;
(function (UpdateShardCountOutput) {
    UpdateShardCountOutput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateShardCountOutput = exports.UpdateShardCountOutput || (exports.UpdateShardCountOutput = {}));
var UpdateStreamModeInput;
(function (UpdateStreamModeInput) {
    UpdateStreamModeInput.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateStreamModeInput = exports.UpdateStreamModeInput || (exports.UpdateStreamModeInput = {}));
