import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListShardsInput, ListShardsOutput } from "../models/models_0";
import { deserializeAws_json1_1ListShardsCommand, serializeAws_json1_1ListShardsCommand, } from "../protocols/Aws_json1_1";
var ListShardsCommand = (function (_super) {
    __extends(ListShardsCommand, _super);
    function ListShardsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListShardsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "KinesisClient";
        var commandName = "ListShardsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListShardsInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListShardsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListShardsCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_1ListShardsCommand(input, context);
    };
    ListShardsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_1ListShardsCommand(output, context);
    };
    return ListShardsCommand;
}($Command));
export { ListShardsCommand };
