import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { KinesisClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../KinesisClient";
import { GetRecordsInput, GetRecordsOutput } from "../models/models_0";
export interface GetRecordsCommandInput extends GetRecordsInput {
}
export interface GetRecordsCommandOutput extends GetRecordsOutput, __MetadataBearer {
}

export declare class GetRecordsCommand extends $Command<GetRecordsCommandInput, GetRecordsCommandOutput, KinesisClientResolvedConfig> {
    readonly input: GetRecordsCommandInput;
    constructor(input: GetRecordsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: KinesisClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetRecordsCommandInput, GetRecordsCommandOutput>;
    private serialize;
    private deserialize;
}
